// GMD - SET - L. Peters Vers. 2.1 - 6.9.93 
#include "membership.h"
#include <stream.h>

inline int abs(int a,int b) {return((a)>(b)?(a-b):(b-a));}

void Mfc::Mfc_Rule( float regel , int t ){
	 Rule = regel;
	Nr  = t;
	switch (t)
	 {
	case 2: Mfc::Glocke = & Mfc::Mfc_l;
		break;
	case 3: Mfc::Glocke = & Mfc::Mfc_r;
		break;
	default: Mfc::Glocke = & Mfc::Mfc_m;
	}
}
	
double Mfc::Mfc_Mu (double e1)
{

 return (this->*Glocke) (e1);
}
void Mfc::Mfc_print(void)
{ 
	cout << "\n"<< "regel ="<< Rule<<" Fkttyp= "<< Nr;
        cout << " Co = "<< Co <<" k = " << K << " Mu = " << Mu <<"\n";
}

float Mfc::Mfc_prk(void)
{
return(K);
}

double Mfc::Mfc_m(double e1) {	
	Mu = Co/(1+(e1-Rule)*(e1-Rule)/K);
	return Mu;
}
double Mfc::Mfc_l(double e1) {	
	if (e1<=Rule)
		Mu = Co;
	else
		Mu = Co/(1+(e1-Rule)*(e1-Rule)/K);
	return Mu;
}
double Mfc::Mfc_r(double e1) {	
	if (e1>=Rule)
		Mu = Co;
	else
		Mu = Co/(1+(e1-Rule)*(e1-Rule)/K);
	return Mu;
}	


Mfc& Mfc:: operator =( const Mfc &wert) {
	Nr = wert.Nr;
	Rule = wert.Rule;
	Co = wert.Co;
	K = wert.K;
	Mu = wert.Mu;
	Glocke = wert.Glocke;
	return *this;
}

//UND  Funktion  (min)
Mfc& Mfc:: operator &(Mfc& wert){      
      if (Mu<=wert.Mu) 
                return *this;
        else
                return wert;

}
// OR Funktion (max)
Mfc& Mfc:: operator |(Mfc& wert) {

          if (Mu>=wert.Mu) 
                return *this;
        else
                return wert;

}
// cut Function 

 Mfc& Mfc:: operator <(double y) {
   Mfc *dummy;
   dummy = this;    
        if (y < Mu) 
                dummy->Mu = y;
   return *dummy;
} 

Mfc& Mfc:: operator <(Mfc & wert) {
   Mfc *dummy;
   dummy = this;    
        if (wert.Mu < Mu) 
                dummy->Mu = wert.Mu;
   return *dummy;
}

Mfc& Mfc::operator ()( double e1) {
 double dummy;
	dummy= (this->*Glocke)(e1);
	return *this;
}

// Membership Array

	Mfc_Array::Mfc_Array()  {
	Groesse = 0;
	Mat = 0;
	Mfc_Array_defrule();
//	Mfc_Array::Defuzzy = & Mfc_Array::DefOut;
//	Def_typ = 0;
	Coef = 0;
	Out = 0;
	Dim_zg=1;
 }
 void  Mfc_Array::Mfc_Array_init (int gr,int *Cx, float *kx, int df) {
	delete [] Mat;
	Groesse = gr;
	Mat = new Mfc [Groesse];
	for (int i = 0 ; i< Groesse; i++)
		Mat[i].Mfc_init(Cx[i], kx[i]);
	Mfc_Array_defrule(df);

}
void Mfc_Array::Mfc_Array_rule (int gr, double *regel, int  *t) {
	if (gr != Groesse)
	cout << "\n kann nicht initialisieren Groesse= "<< Groesse<<"\n";
	else
	{   int i;
	    if (t == 0)
	    	for (i=0; i<Groesse; i++)
		 	Mat[i].Mfc_Rule(regel[i]);
            else
		for (i=0; i<Groesse; i++)
		 	Mat[i].Mfc_Rule(regel[i], t[i]);
	}
}
void Mfc_Array::Mfc_Array_defrule (int t){
	Def_typ = t;
	switch (t)
	{ case 0:
		Mfc_Array::Defuzzy = & Mfc_Array::DefOut;
		break;
	  case 1:
		Mfc_Array::Defuzzy = & Mfc_Array::DefMaxOut;
		break;

	default:
		Mfc_Array::Defuzzy = & Mfc_Array::DefOut;
		Def_typ = 0;
	}

	

}
void Mfc_Array::Mfc_Array_mu (double *e1, double*e2)
{    	int i;
	if (!Coef){
	for (int i = 0; i<Groesse; i++)
	  e2[i]= Mat[i].Mfc_Mu(e1[i]);
	}
	else {
	for (i = 0; i<Groesse; i++)
	  e2[i]= Mat[i].Mfc_Mu(e1[i])* Coef[i];
	     }

}

void Mfc_Array::Mfc_Array_print(void)
{ 	for (int i=0; i< Groesse; i++)
		Mat[i].Mfc_print();
	
}
float*  Mfc_Array::Mfc_Array_prk()
{
float *a;
a = new float [Groesse];
for (int i =0; i<Groesse; i++)
	a[i] = Mat[i].Mfc_prk(); 
return a;
}
float*  Mfc_Array::Mfc_Array_prregel()
{
float *a;
a = new float [Groesse];
for (int i =0; i<Groesse; i++)
	a[i] = Mat[i].Rule; 
return a;
}
void Mfc_Array::Mfc_Array_prmu(float* a)
{
for (int i = 0; i< Groesse; i++)
	a[i] = Mat[i].Mu;
}
Mfc_Array& Mfc_Array::Mfc_Array_out(void){
	double dummy;
	for (int i=0; i<Groesse; i++)
		dummy=Mat[i].Mfc_Mu(Mat[i].Rule);
	return *this;
}
double*  Mfc_Array::Mfc_Array_mat(){
	  double *m;
	m = new double [Groesse];
	for (int i=0 ; i< Groesse; i++)
		m[i] = Mat[i].Mu;
	return (m);

}


//operatoren

Mfc_Array& Mfc_Array::operator = (Mfc_Array &A) {
	if (Mat != A.Mat)
	{
	delete [] Mat;
	Groesse= A.Groesse;
	Mat = new Mfc [Groesse];
	for (int i=0;i<Groesse; i++) 
		Mat[i] = A.Mat[i];
	Defuzzy = A. Defuzzy;
	Dim_zg = A.Dim_zg;
	Def_typ = A.Def_typ;
	Out = A.Out;
	Coef = A.Coef;
	}
      
	return *this;
}			
Mfc& Mfc_Array::operator [](int Index) {
	return Mat[Index];


}


//UND  Funktion  (min)
Mfc_Array& Mfc_Array:: operator &(Mfc_Array& wert){      
      for (int i=0; i<Groesse; i++)
	  this->Mat[i] = this->Mat[i] & wert.Mat[i];
      return *this;

}
// OR Funktion (max)
Mfc_Array& Mfc_Array:: operator |(Mfc_Array& wert) {
      for (int i=0; i<Groesse; i++)
	  this->Mat[i] = this->Mat[i] | wert.Mat[i];
      return *this;

}
// cut Function 

 Mfc_Array& Mfc_Array:: operator <(double *y) {

      for (int i=0; i<Groesse; i++)
	  this->Mat[i] = this->Mat[i] < y[i];
      return *this;
 
} 

Mfc_Array& Mfc_Array:: operator <(Mfc_Array & wert) {

      for (int i=0; i<Groesse; i++)
	  this->Mat[i] = this->Mat[i] < wert.Mat[i];
      return *this;
}

Mfc_Array& Mfc_Array::operator ()( double e1) {
 double dummy;
	int i;
	if(!Coef){
	for ( i =0; i< Groesse; i++)
	dummy= Mat[i].Mfc_Mu(e1);
	return *this;
	}
	else {
	for ( i =0; i< Groesse; i++)
	dummy= Mat[i].Mfc_Mu(e1)* Coef[i];
	return *this;
	}

}
double  Mfc_Array::Defuz() {

 return ((this->*Defuzzy)());
}

double  Mfc_Array::DefOut()  {
	double s1=0, s2=0;

	for (int i=0; i< Groesse; i++) {
		s1 += Mat[i].Rule * Mat[i].Mu; 
		s2 += Mat[i].Mu;
	}
	if (s2 < 0.001) 
	  Out =0;
	else
		Out = s1/s2;
	return (Out);
}

double Mfc_Array::DefMaxOut() {
double s1 = Mat[0].Mu;
int nr=0;
for (int i=1; i< Groesse; i++)
	 if (s1 <Mat[i].Mu)
		{ s1 = Mat[i].Mu;
     	          nr = i;
		}
	return (Mat[nr].Rule);
}
int Mfc_Array::Mfc_Array_gr() {
	return (Groesse);
	}

// Membership Array with loop
	Mfc_Loop:: Mfc_Loop(): Mfc_Array() {
	Dim = FIFO; Fifo = new double [Dim];
	 for (int i =0; i<Dim; i++)
		Fifo[i] = 0;
	Mfc_Array_defrule();
//	Mfc_Array::Defuzzy = & Mfc_Array::DefOut;
//	Def_typ = 1;
	Delta = DELTA; Delta_a = DELTA_A;

	Loop = 0; Loop_coef = 0; Verfolge = 0;
	
}

	Mfc_Loop:: ~Mfc_Loop() { 
		delete [Dim] Fifo;
		delete [Groesse] Loop; delete [Groesse] Loop_coef;
}

void Mfc_Loop::Mfc_Array_print(void)
{ 	for (int i=0; i< Groesse; i++){
		Mat[i].Mfc_print();
		cout << " y_coef: "<< Loop_coef[i];
		}
		
	
}
Mfc_Array& Mfc_Loop::operator ()( double e1) {
 double dummy;
	for (int i =0; i< Groesse; i++){
	dummy= Mat[i].Mfc_Mu(e1);
	Mat[i].Mu = dummy * Loop_coef[i];
	}
	return *this;
}

void Mfc_Loop::Mfc_Loop_schleife(double d, double da, int f){
	delete [Dim] Fifo;
	Dim = f; Fifo = new double [Dim];
	 for (int i =0; i<Dim; i++)
		Fifo[i] = 0;
	Delta = d; Delta_a = da;
}
	
void Mfc_Loop::Mfc_Loop_conpin (Mfc_Array& a, double *pin){
	Verfolge = pin;
	Ein = & a;
	Groesse = a.Mfc_Array_gr();
	Loop = new double [Groesse];
	Loop_coef = new double [ Groesse];
	for (int i = 0 ; i< Groesse; i++) {
		Loop[i] = 0;
		Loop_coef [i] = 1.0;
	}
	a.Coef = Loop_coef;

} 
void Mfc_Loop::Mfc_Loop_conchip (Mfc_Array& a , Mfc_Array& pin){
	Verfolge = &(pin.Out);
	Ein = & a;
	Groesse = a.Mfc_Array_gr();
	Loop = new double [Groesse];
	Loop_coef = new double [ Groesse];
	for (int i = 0 ; i< Groesse; i++) {
		Loop[i] = 0;
		Loop_coef [i] = 1.0;
	}
	a.Coef = Loop_coef;


} 
void Mfc_Loop::Mfc_Loop_transfer(){
	int posM=Groesse, posm= Groesse, i;
	double max=0, min=0; 
	double *y;
	y = new double [Groesse];
	y=Ein->Mfc_Array_mat();
	Fifo[0]= *Verfolge;
	static int anz1=1, anz2=0, takt1, takt2;
	int tg = 0;
	if (anz1 !=0)
	{
	 if (Fifo[0]-Fifo[1]< - DELTA)
		{ 
		if ((abs(takt1,anz1) < 2) && (abs(takt2,anz1) < 2))
		   {for (i=0;i<Groesse;i++)
                        if (Loop[i]>max) { posM=i; max=Loop[i]; }
		          Loop_coef[posM]=Loop_coef[posM]-0.1;
				tg = anz1;
                    }     
		takt1 = anz1; anz1 =0; anz2 = 1; 
		}
	 else 
		{ anz1++; }
	}
	else
	{
	 if  (Fifo[0]-Fifo[1]> DELTA)
		{ if ((abs ( takt1,anz2)<2) && (abs ( takt2,anz2) < 2))
		    {for (i=0;i<Groesse;i++)
                        if (Loop[i]>max) { posM=i; max=Loop[i]; }
		          Loop_coef[posM]=Loop_coef[posM] + 0.2;
			    tg = anz2;
                    }     
		
		takt2 = anz2; anz2 = 0; anz1 = 1; 
		}
	 else
		{ anz2++; }
	}
	
 if (tg>0)
	tg--;
 else
	{ for (i=0; i<Groesse; i++)
                {   if( Loop_coef[i]>1.0) 
                Loop_coef[i]=1.0>(Loop_coef[i]-0.1)? 1.0 : (Loop_coef[i]-0.1);
                    if( Loop_coef[i]<1.0) 
                Loop_coef[i]=1.0 < (Loop_coef[i]+0.05)? 1.0 : (Loop_coef[i]+0.05) ;
                }
	}
	/* Fifo shiften */
//        for (i=0;i<Dim-1;i++)
//                Fifo[i+1]=Fifo[i];
	Fifo[1] = Fifo[0];
        for (i=0; i<Groesse ;i++)
                Loop[i]=y[i];


delete [Groesse] y;

 


}


